function [b, alpha, gamma, mu, sigma, Xsv] = extractrbfsvmparams(svmmodel, Xtr)
% Created by John Reidar Mathiasse, August 18, 2016

b = svmmodel.Bias;
alpha = svmmodel.Alpha;

gamma = 1/(1.0*svmmodel.KernelParameters.Scale^2);
% gamma = svmmodel.KernelParameters.Scale;
mu = svmmodel.Mu;
sigma = svmmodel.Sigma;
Xsv = Xtr(svmmodel.IsSupportVector,:);

end