function [mdl] = fitcvoneclasscsvm(X,k,gexp,outlierfraction)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

n = size(X,1);
y = ones(n,1);


c = cvpartition(n,'KFold',k);

cverror = zeros(length(gexp),k);
tic;
for ifold = 1:k
    
    disp(sprintf('Fold %u of %u',ifold,k));
    
    % Train
    Xtr = X(c.training(ifold),:);
    ytr = y(c.training(ifold),:);
    
    % Test
    Xte = X(c.test(ifold),:);
    yte = y(c.test(ifold),:);
    
    % Standardize
    % mu = mean(Xtr,1);
    % si = std(Xtr,1);
    % si(si == 0) = 1;
    %
    % for dim = 1:size(X,2)
    %
    %     Xtr(:,dim) = (Xtr(:,dim) - mu(dim))/si(dim);
    %     Xte(:,dim) = (Xte(:,dim) - mu(dim))/si(dim);
    % end
    
%     for icexp = 1:length(cexp)
        for igexp = 1:length(gexp)
            
            %
            gamma = 2^gexp(igexp);
            sigma = sqrt(1/2*gamma);
            
            mdld = fitcsvm(Xtr,ytr,'Standardize','on','KernelFunction','gaussian','KernelScale',sigma,'Solver','SMO','Outlierfraction',outlierfraction);
            
            [~,ydfit] = predict(mdld,Xte);
            ydtest = yte;
            
            cverror1(igexp,ifold) = mean(sign(ydfit) ~= sign(ydtest));
            %                 cverror2(icexp,igexp,ifold) = mean(abs(ydfit-ydtest));
            %                 cverror3(icexp,igexp,ifold) = mean((ydfit-ydtest).^2);
        end
%     end
    
end

mcverror1 = mean(cverror1,2);

%     mcverror2 = sum(cverror2,3)/k;
%     mcverror3 = sum(cverror3,3)/k;
%
% figure;imagesc(rmserror);axis equal;axis tight;colorbar;
%
% figure;imagesc(mcverror2);axis equal;axis tight;colorbar;
%
% figure;imagesc(mcverror3);axis equal;axis tight;colorbar;
disp(' ');
toc


cv1bestigexp = 1;
bestcv1 = inf;

    for igexp = 1:length(gexp)
        if mcverror1(igexp) < bestcv1
            bestcv1 = mcverror1(igexp);
            
            cv1bestigexp = igexp;
        end
    end



gamma = 2^gexp(cv1bestigexp);
sigma = sqrt(1/2*gamma);

mdls = fitcsvm(X,y,'Standardize','on','KernelFunction','gaussian','KernelScale',sigma,'Solver','SMO','Outlierfraction',outlierfraction);

mdl = mdls;


