% OneSVMtest
%
% Created by John Reidar Mathiassen, August 18, 2016. Updated 14.09.2016.

% load('..\Data\densodatafeaturesmod2.mat');
%load('..\Data\KORREKT_ALLE.mat');
% load('..\Data\abalone.mat');

% load fisheriris
% X = meas(:,1:2);

% outlierid = randi(size(y,1),[100 1]);
% y(outlierid,:) = 50*rand(size(y(outlierid,:)));

Z = [X y];

outlierfraction = 0.10;

yones = ones(size(Z,1),1);

% SVMModel1 = fitcsvm(Z,yones,'KernelFunction','gaussian','KernelScale','auto','Standardize',true,...
%     'OutlierFraction',outlierfraction);
% SVMModel2 = fitcsvm(X,yones,'KernelFunction','gaussian','KernelScale','auto','Standardize',true,...
%     'OutlierFraction',outlierfraction);

gexp = -8:0.5:15;

k = 10;
disp('Z');
disp('...');
SVMModel1 = fitcvoneclasscsvm(Z,k,gexp,outlierfraction);
disp('X');
disp('...');
SVMModel2 = fitcvoneclasscsvm(X,k,gexp,outlierfraction);

[~,score1] = predict(SVMModel1,Z);
[~,score2] = predict(SVMModel2,X);

idxoutliers1 = score1 < 0;
idxoutliers2 = score2 > 0;

sum(idxoutliers1)
sum(idxoutliers2)

figure;stem(idxoutliers1);
hold on;stem(0.5*idxoutliers2,'r');

idxspecialoutliers = idxoutliers1 & idxoutliers2;
sum(idxspecialoutliers)
idxspecialoutliers = find(idxspecialoutliers);

d = size(X,2);
dr = size(y,2);

figure;
plotnum = 1;
for id = 1:d
    for idr = 1:dr
        
        subplot(d,dr,plotnum);
        plot(X(:,id),y(:,idr),'k.');hold on;
        
        if ~isempty(idxspecialoutliers)
        plot(X(idxspecialoutliers(1),id),y(idxspecialoutliers(1),idr),'ro');
            if length(idxspecialoutliers) > 1
                plot(X(idxspecialoutliers(2),id),y(idxspecialoutliers(2),idr),'go');
                if length(idxspecialoutliers) > 2
                    plot(X(idxspecialoutliers(3),id),y(idxspecialoutliers(3),idr),'mo');
                    if length(idxspecialoutliers) > 3
                        plot(X(idxspecialoutliers(4),id),y(idxspecialoutliers(4),idr),'bo');
                        if length(idxspecialoutliers) > 3
                            plot(X(idxspecialoutliers(5:end),id),y(idxspecialoutliers(5:end),idr),'ko');
                        end
                    end
                end
            end
        end
        
        
        
        
%         plot(X(idxspecialoutliers,id),y(idxspecialoutliers,idr),'ro');
%         plot(X(idxspecialoutliers,id),y(idxspecialoutliers,idr),'rx');
        grid on;
        xlabel(sprintf('x_%u',id));
        ylabel(sprintf('y_%u',idr));
        plotnum = plotnum + 1;
    end
end


idxconsistent = ~(idxoutliers1 & idxoutliers2);

Xconsistent = X(idxconsistent,:);
yconsistent = y(idxconsistent,:);

% 
% Xip = Xmod(~(idxoutliers1 & idxoutliers2),:);
% yip = y(~(idxoutliers1 & idxoutliers2),:);